package mccity.heroes.skills.turret;

import org.bukkit.Location;
import org.bukkit.entity.Entity;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

public class ExpirableEntityManager {

    private final Map<Entity, Integer> managedEntities = new HashMap<Entity, Integer>();

    public <T extends Entity> T spawn(Location loc, Class<T> clazz, int lifetimeLimit) throws IllegalArgumentException {
        T spawned = loc.getWorld().spawn(loc, clazz);
        managedEntities.put(spawned, lifetimeLimit);
        return spawned;
    }

    public void update() {
        Iterator<Map.Entry<Entity, Integer>> itr = managedEntities.entrySet().iterator();
        while (itr.hasNext()) {
            Map.Entry<Entity, Integer> entry = itr.next();
            if (entry.getKey().getTicksLived() >= entry.getValue()) {
                entry.getKey().remove();
                itr.remove();
            }
        }
    }

    public void despawnAll() {
        for (Entity entity : managedEntities.keySet()) {
            entity.remove();
        }
        managedEntities.clear();
    }
}
